var url = "http://www.apple.com";
var frequency = 1440;
var timeout = null;
var lastHash = null;
var lastUrl = null;

function setup() {
  if (window.widget) {
    widgetSetup();
    readPrefs();
    widget.onremove = clearPrefs;
    widget.onshow = onshow;
    widget.onhide = onhide;
    if (!widget.context) {
      document.getElementById("Widgetop").style.display = "block";
    }
  }
}

function readPrefs() {
  if (window.widget) {
    var value = widget.preferenceForKey(widget.identifier + "-url");
    if (value) {
      url = value;
      lastUrl = value;
    }
    //document.getElementById("Address").innerHTML = url;  #
    updateAddress();
    document.getElementById("UrlInput").value = url;  
    
    var value = widget.preferenceForKey(widget.identifier + "-frequency");
    if (value) {
      frequency = parseInt(value);
    }
    document.getElementById("Frequency").value = frequency;  

    var value = widget.preferenceForKey(widget.identifier + "-hash");
    if (value) {
      lastHash = parseInt(value);
    }

    var value = widget.preferenceForKey(widget.identifier + "-start");
    if (value) {
      document.getElementById("StartInput").value = value;
    }

    var value = widget.preferenceForKey(widget.identifier + "-stop");
    if (value) {
      document.getElementById("StopInput").value = value;
    }
  }
}

function clearPrefs() {
  widget.setPreferenceForKey(null, widget.identifier + "-url");
  widget.setPreferenceForKey(null, widget.identifier + "-frequency");
  widget.setPreferenceForKey(null, widget.identifier + "-hash");
  widget.setPreferenceForKey(null, widget.identifier + "-start");
  widget.setPreferenceForKey(null, widget.identifier + "-stop");
}

function onshow() {
  if (timeout) {
    clearTimeout(timeout);    
  }
  timeout = setTimeout(checkUrl, 1);  
}

function onhide() {
  if (timeout) {
    clearTimeout(timeout);
  }  
  timeout = null;
}

function checkUrl() {
  document.getElementById("Loading").style.display = "block";  
  document.getElementById("LastCheck").innerHTML = "Checking...";  
  var request = new XMLHttpRequest();
  request.open("GET", url, true);
  request.onload = function() {
    urlChecked(request);
  }
  request.send(null);
  if (timeout) {
    clearTimeout(timeout);
    timeout = null;    
  }
  if (frequency != 0) {
    timeout = setTimeout(checkUrl, frequency * 60000);
  }  
}

function urlChecked(request) {
  var date = new Date();
  document.getElementById("Loading").style.display = "none";  
  if (request.status == 200) {
    document.getElementById("LastCheck").innerHTML = "Last Check: " + date.toLocaleTimeString();  
    var text = request.responseText;
    var start = document.getElementById("StartInput").value;
    if (start.length > 0) {
      var index = text.indexOf(start);
      if (index > 0) {
        text = text.substring(index);
      }
    }
    var end = document.getElementById("StopInput").value;
    if (end.length > 0) {
      var index = text.indexOf(end);
      if (index > 0) {
        text = text.substring(0, index);
      }
    }
    var hash = 0;
    for (var i = 0; i < text.length; i++) {
    	hash += text.charCodeAt(i);
    }
    if (lastHash && lastHash != hash) {
      document.getElementById("Alert").style.display = "block";
    }
    lastHash = hash;
    widget.setPreferenceForKey(hash, widget.identifier + "-hash");
    document.getElementById("LastCheck").style.color = null;  
  }
  else {
    document.getElementById("LastCheck").innerHTML = "Check failed: " + date.toLocaleTimeString();
    document.getElementById("LastCheck").style.color = "orange";  
  }
}

function openUrl() {
  widget.openURL(url);
}

function closeAlert() {
  document.getElementById("Alert").style.display = "none";
}

function updateAddress() {
  document.getElementById("Address").innerHTML = url;
  if (url.indexOf("www.widgetop.com") >= 0) {
    document.getElementById("SnapShot").src = "widgetop.png";
  }
  else {
    document.getElementById("SnapShot").src = "http://images.websnapr.com/?url=" 
                                              + encodeURIComponent(url) 
                                              + "&size=S";
  }
  if (url != lastUrl) {
    lastHash = null;
    lastUrl = url;
  }  
}

function showHelp() {
  document.getElementById("Help").style.display = "block";
}

function closeHelp() {
  document.getElementById("Help").style.display = "none";  
}

function widgetSetup() {
  if (window.widget) {
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
  	var gHelpButton = new AppleGlassButton(document.getElementById("HelpButton"), 
  	                                      "Help", showHelp); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "white", "white", showBack);    
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if(window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    window.resizeTo(220, 290);
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    window.resizeTo(160, 140);
    url = document.getElementById("UrlInput").value;
    updateAddress();
    //document.getElementById("Address").innerHTML = url;
    frequency = parseInt(document.getElementById("Frequency").value);
    widget.setPreferenceForKey(url, widget.identifier + "-url");
    widget.setPreferenceForKey(frequency, widget.identifier + "-frequency");
    widget.setPreferenceForKey(document.getElementById("StartInput").value, widget.identifier + "-start");
    widget.setPreferenceForKey(document.getElementById("StopInput").value, widget.identifier + "-stop");
    document.getElementById("Background").style.backgroundImage = "";//null;
    checkUrl();
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

if (top.myBrowser.needsXMLHttpRequestVariable) {var XMLHttpRequest;}